set serveroutput on
DECLARE 
  CURSOR C_USERS IS	(
    SELECT distinct GRANTEE as USERNAME
    FROM USER_TAB_PRIVS
    WHERE OWNER = user
  );
  
	CURSOR C_SYNONYM_USER (USERNAME_IN VARCHAR2) IS	(
    SELECT GRANTEE, 'CREATE OR REPLACE SYNONYM '|| 
           (case 
             when TABLE_NAME = 'VESSEL_POSITION_COMPLETE' then 'VESSEL_POSITION' 
             when TABLE_NAME = 'FISHING_TRIP_PUBLIC' then 'FISHING_TRIP' 
             when TABLE_NAME = 'QUANTIFICATION_MEASUREMENT_B' then 'QUANTIFICATION_MEASUREMENT' 
             when TABLE_NAME = 'SORTING_MEASUREMENT_B' then 'SORTING_MEASUREMENT' 
             when TABLE_NAME = 'F_FILL_PERSON_SESSION' then 'NF_FILL_PERSON_SESSION'
			 when TABLE_NAME = 'F_TRANSFERT_FISHING_TRIP2SALE' then 'NF_TRANSFERT_FISHING_TRIP2SALE'
             else TABLE_NAME
           end)
           || ' FOR ' || OWNER || '.' || TABLE_NAME || ';' as STRQUERY
    FROM (SELECT distinct TABLE_NAME, OWNER, GRANTEE FROM USER_TAB_PRIVS)
    WHERE OWNER = user
      AND TABLE_NAME NOT LIKE '%$%'
      AND GRANTEE = USERNAME_IN
  );
BEGIN
  FOR USERS IN C_USERS LOOP
    dbms_output.put_line('-- ##############################################################') ;
    dbms_output.put_line('connect ' || USERS.USERNAME || '/' || USERS.USERNAME || '@VINSTA') ;
    FOR QUERY_GRANT IN C_SYNONYM_USER(USERS.USERNAME) LOOP
      dbms_output.put_line( QUERY_GRANT.STRQUERY ) ;
    END LOOP ;
  END LOOP;
END;
/